<div class="contenedor">
  <app-side-bar></app-side-bar>
  <div class="position-relative">
    <div class="position-relative d-flex justify-content-between align-items-center p-3">
      <!-- Titulo de la página, buscador y calendario -->
      <div class="d-flex align-items-center">
        <h1 class="me-4">Usuarios</h1>
        <div>
          <button (click)="openEmptyForm()" class="btn btn-primary add">+</button>
        </div>
      </div>
      <div class="d-flex">
        <!-- Calendario -->
        <div class="d-flex align-items-center position-relative">
          <div [ngClass]="{'pressed-button': startDate.value !== ''}" class="pressed-button me-4">
            <img class="cursor-pointer" (click)="openCalendar()" src="assets/img/calendario.svg">
          </div>
          <form #calendar class="col visibility-hidden sombra calendario">
            <img class="cross position-absolute cursor-pointer" (click)="closeCalendar()" src="assets/img/xmark.svg">
            <div class="row d-flex mb-3">
              <div class="col-sm-6 max-content mb-2">
                <p class="max-content">Inicio</p>
                <input #startDate type="date">
              </div>
              <div class="col-sm-6 max-content mb-2">
                <p class="max-content">Fin</p>
                <input #endDate type="date">
              </div>
            </div>
            <div class="justify-content-center d-flex">
              <button (click)="removeDate()" class="btn btn-outline-secondary me-3">Borrar</button>
              <button (click)="searchDate()" class="btn btn-primary text-white">Buscar</button>
            </div>
          </form>
        </div>
        <!-- Buscador -->
        <div class="position-relative align-items-center d-flex">
          <input #searchInput (input)="search($event)" class="align-self-center buscador entrada sombra" type="text" placeholder="Buscar" name="buscar">
          <ul *ngIf="searchResults.length > 0" class="list-group position-absolute busqueda">
            <li *ngFor="let result of searchResults" class="list-group-item" (click)="selectResult(result)">
              <span [innerHTML]="result"></span>
            </li>
          </ul>
        </div>
      </div>
    </div>
    <!-- Tabla -->
    <div class="alturaTabla">
      <table class="table table-hover">
        <thead>
          <tr>
            <!-- <th>
              <div class="d-flex align-items-center">
                <div class="custom-control custom-checkbox ml">
                  <input type="checkbox" class="custom-control-input" id="customCheck2">
                </div>
                <div class="d-flex flex-direction mFlechas visibility-hidden">
                  <img class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th> -->
            <th>
              <div class="d-flex align-items-center">
                <div>
                  Usuario
                </div>
                <div class="d-flex flex-direction mFlechas">
                  <img (click)="ordenar('asc', 'username')" class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img (click)="ordenar('desc', 'username')" class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th>
            <th>
              <div class="d-flex align-items-center">
                <div>
                  Email
                </div>
                <div class="d-flex flex-direction mFlechas">
                  <img (click)="ordenar('asc', 'username')" class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img (click)="ordenar('desc', 'username')" class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th>
            <th>
              <div class="d-flex align-items-center">
                <div>
                  Nombre
                </div>
                <div class="d-flex flex-direction mFlechas">
                  <img (click)="ordenar('asc', 'nombre')" class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img (click)="ordenar('desc', 'nombre')" class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th>
            <th>
              <div class="d-flex align-items-center">
                <div>
                  Apellidos
                </div>
                <div class="d-flex flex-direction mFlechas">
                  <img (click)="ordenar('asc', 'apellidos')" class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img (click)="ordenar('desc', 'apellidos')" class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th>
            <th>
              <div class="d-flex align-items-center">
                <div>
                  Rol
                </div>
                <div class="d-flex flex-direction mFlechas">
                  <img (click)="ordenar('asc', 'rol')" class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img (click)="ordenar('desc', 'rol')" class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th>
            <th>
              <div class="d-flex align-items-center">
                <div>
                  Especialidad
                </div>
                <div class="d-flex flex-direction mFlechas">
                  <img (click)="ordenar('asc', 'especialidad')" class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img (click)="ordenar('desc', 'especialidad')" class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th>
            <th>
              <div class="d-flex align-items-center">
                <div>
                  Fecha de Alta
                </div>
                <div class="d-flex flex-direction mFlechas">
                  <img (click)="ordenar('asc', 'fechaAlta')" class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img (click)="ordenar('desc', 'fechaAlta')" class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th>
            <th>
              <div class="d-flex align-items-center">
                <div>
                  Último acceso
                </div>
                <div class="d-flex flex-direction mFlechas">
                  <img (click)="ordenar('asc', 'ultimoAcceso')" class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img (click)="ordenar('desc', 'ultimoAcceso')" class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th>
            <th>
              <div class="d-flex align-items-center">
                <div>
                  Actividad
                </div>
                <div class="d-flex flex-direction mFlechas">
                  <img (click)="ordenar('asc', 'activo')" class="flechas cursor-pointer" src="assets/img/flecha_arriba_blanca.svg">
                  <img (click)="ordenar('desc', 'activo')" class="flechas cursor-pointer" src="assets/img/flecha_abajo_blanca.svg">
                </div>
              </div>
            </th>
            <th>
              <div class="d-flex align-items-center">
                <div>
                  Acciones
                </div>
                <div class="d-flex flex-direction mFlechas" style="visibility: hidden;">
                  <img class="flechas cursor-pointer" src="../../../assets/img/arriba.svg">
                  <img class="flechas cursor-pointer" src="../../../assets/img/abajo.svg">
                </div>
              </div>
            </th>
          </tr>
      </thead>
      <tbody *ngIf="loadCompleted">
        <tr *ngFor="let usuario of usuarios; let i = index">
          <!-- <td>
            <div class="custom-control custom-checkbox ml tamCelda0">
                <input type="checkbox" class="custom-control-input" id="customCheck2">
            </div>
          </td> -->
          <td class="align-items-center">{{usuario.username}}</td>
          <td class="align-items-center">{{usuario.email}}</td>
          <td class="align-items-center">{{usuario.nombre}}</td>
          <td class="align-items-center" [title]="usuario.apellidos">
            <div class="tamCelda3">
              {{usuario.apellidos}}
            </div>
          </td>
          <td class="align-items-center">{{usuario.rol}}</td>
          <td class="align-items-center">{{usuario.especialidad}}</td>
          <td class="align-items-center">{{usuario.fechaAlta | date:'dd/MM/yy, h:mm a'}}</td>
          <td class="align-items-center">{{usuario.ultimoAcceso | date:'dd/MM/yy, h:mm:ss a'}}</td>
          <td class="align-items-center">
            <div (click)="enableUser(usuario.uid, usuario.nombre, usuario.apellidos, usuario.activo)" class="boton cursor-pointer" [ngClass]="{'activo': usuario.activo, 'inactivo': !usuario.activo}"
            [innerText]="usuario.activo ? 'activo' : 'inactivo'">
            </div>
          </td>
          <td>
            <img (click)="openEditForm(usuario)" class="icono cursor-pointer" src="assets/img/edit.svg">
            <!-- <img (click)="disableUser(usuario.uid, usuario.nombre, usuario.apellidos)" class="icono cursor-pointer" src="assets/img/delete.svg"> -->
        </td>
        </tr>
      </tbody>
      </table>
    </div>
    <!-- Loading -->
    <div class="d-flex justify-content-center loading" *ngIf="!loadCompleted">
      cargando
    </div>
    <!-- Paginacion -->
    <div class="mt-2 position-absolute bottom-0 w-100">
      <app-pagination (changePage)="changePage($event)" [dataLoaded]="loadCompleted" [recordsTotal]="recordsTotal" [recordCurrent]="recordCurrent + 1" [recordsPerPage]="recordsPerPage"></app-pagination>
    </div>
    <!-- Formulario -->
    <section #modal class="d-flex justify-content-center align-items-center ventanaModal visibility-hidden">
      <div id="modal">
        <h4 *ngIf="!create" class="text-white text-center">Editar Usuario</h4>
        <h4 *ngIf="create" class="text-white text-center">Crear Usuario</h4>
        <form class="p4" [formGroup]="userForm" (submit)="editUser()">
          <div class="form-group d-flex justify-content-between mb-3">
            <div class="tamInput">
              <label for="cliente" class="form-label">Usuario</label>
              <input type="text" formControlName="username"  class="form-control" placeholder="Ej. pepito23" required autofocus>
            </div>
            <div *ngIf="create" class="tamInput">
              <label for="password" class="form-label">Contraseña</label>
              <input type="text" formControlName="password"  class="form-control" required>
            </div>
            <div *ngIf="!create" class="tamInput">
              <label class="form-label">Restablecer contraseña</label>
              <input #newPassword type="text"  class="form-control" required>
            </div>
          </div>
          <div class="mb-3">
            <label for="email" class="form-label">Email</label>
            <input type="text" formControlName="email" class="form-control" placeholder="Ej. ejemplo@dominio.com" required>
            <div class="mt-2" *ngIf="userForm.controls['email'].invalid && (userForm.controls['email'].dirty || userForm.controls['email'].touched)">
              <p class="text-danger" *ngIf="userForm.controls['email'].errors!['email']">Formato email erróneo</p>
            </div>
          </div>
          <div class="form-group d-flex justify-content-between mb-3">
            <div class="tamInput">
              <label for="nombre" class="form-label">Nombre</label>
              <input type="text" formControlName="nombre" class="form-control" required>
            </div>
            <div class="tamInput">
              <label for="apellidos" class="form-label">Apellidos</label>
              <input type="text" formControlName="apellidos" class="form-control" required>
            </div>
          </div>
          <div class="form-group d-flex justify-content-between mb-3">
            <div class="tamInput">
              <label for="rol" class="form-label">Rol</label>
              <select formControlName="rol" class="form-control" required>
                <option [selected]="create ? true : false" value="">-</option>
                <option value="usuario">Usuario</option>
                  <option value="admin">Admin</option>
              </select>
            </div>
            <div class="tamInput">
              <label for="especialidad" class="form-label">Especialidad</label>
              <div class="d-flex">
                <select formControlName="especialidad" class="form-control me-2" required>
                  <option [selected]="create ? true : false" value="">-</option>
                  <option *ngFor="let especialidad of especialidades"
                  [value]="especialidad.nombre">
                  {{ especialidad.nombre | titlecase }}
                  </option>
                </select>
                <button class="btn btn-primary" type="button" data-bs-toggle="collapse" data-bs-target="#collapseExample" aria-expanded="false" aria-controls="collapseExample">
                  Editar
                </button>

              </div>
            </div>
          </div>
          <div class="collapse mb-3" id="collapseExample">
            <div class="card card-body">
              <div class="mb-3">
                <label class="form-label">Añadir o eliminar especialidad</label>
                <div class="d-flex">
                  <input #especialidad (input)="lowerCase($event)" type="text" class="form-control me-4">
                  <button type="button" class="btn btn-success me-4" (click)="addSpeciality()">Añadir</button>
                  <button type="button" class="btn btn-danger" (click)="deleteSpeciality()">Eliminar</button>
                </div>
              </div>
            </div>
          </div>
          <p class="text-danger" *ngIf="formInvalid">Todos los campos son obligatorios</p>
          <div class="d-flex justify-content-center">
            <button (click)="hideForm()" type="button" class="btn text-white bgGray me-4">Cancelar</button>
            <button *ngIf="!create" type="submit" class="btn text-white btnPrimary">Guardar</button>
            <button *ngIf="create" type="button" (click)="createUser()" class="btn text-white btnPrimary">Crear</button>
          </div>
        </form>
      </div>
    </section>
  </div>
</div>
